<template>
  <v-select
    :model-value="selectedAmenities"
    label="Услуги"
    :items="amenities"
    :loading="isLoading"
    hide-details
    return-object
    multiple
    @update:focused="onFocus"
  >
    <template #prepend-item>
      <section class="p-3">
        <v-text-field
          :clearable="!isLoading"
          flat
          variant="solo-filled"
          prepend-inner-icon="mdi-magnify"
          placeholder="Поиск"
          type="input"
          hide-details
          density="comfortable"
          @input="onSearchInput"
          @click:clear="term = ''"
        >
          <template #append-inner>
            <v-btn
              v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
              icon="mdi-shield-alert-outline"
              variant="plain"
              size="small"
              :ripple="false"
            />
          </template>
        </v-text-field>
      </section>
    </template>

    <template #item="{ item, props }">
      <!--Leave title empty to fix vue warnings-->
      <v-list-item
        v-bind="props"
        title=""
        class="py-2 [&_.v-list-item-title]:whitespace-normal [&_.v-list-item-title]:max-w-[350px]"
        :active="checkAmenitySelected(item.value)"
        :value="item.value"
        @click="selectAmenity(item.value)"
      >
        <template #title>
          <section class="flex items-center gap-2">
            <v-icon
              :icon="checkAmenitySelected(item.value) ? 'mdi-tag' : 'mdi-tag-outline'"
              class="text-gray-600"
            />

            <section>
              {{ item.value.name }}
            </section>
          </section>
        </template>

        <template #subtitle>
          <section class="mt-2 ml-6">
            <ProfitDisplay
              :value="item.value.profit"
              mode="chip"
            />
          </section>
        </template>
      </v-list-item>
    </template>

    <template #selection="{ index }">
      <section v-if="index === 0">
        Выбрано услуг: <b>{{ selectedAmenities.length }}</b>
      </section>
    </template>

    <template #append-item>
      <InlineLoadingIndicator
        v-if="isLoading"
        embedded
      />

      <div
        v-intersect="onFullyScrolled"
        class="h-4"
      />
    </template>

    <template #no-data>
      <EmptyState
        v-if="!isLoading && !amenities.length"
        embedded
      />
    </template>
  </v-select>

  <v-scroll-y-transition>
    <section
      v-if="selectedAmenities.length"
      class="mt-2"
    >
      <v-list lines="two">
        <v-scroll-y-transition group>
          <v-list-item
            v-for="(amenity, index) in selectedAmenities"
            :key="amenity.id"
            :title="amenity.name"
            :subtitle="amenity.profit"
            class="[&_.v-list-item-title]:whitespace-normal"
            :class="{ 'bg-gray-100': index % 2 === 0 }"
          >
            <template #prepend>
              <section class="flex items-center gap-2 mr-2">
                <section>
                  <v-btn
                    :disabled="amenity.quantity === 1"
                    class="block !h-full rounded-none py-2"
                    icon="mdi-minus"
                    variant="plain"
                    size="x-small"
                    @click="decreaseAmenityQuantity(amenity)"
                  />
                </section>

                <section>
                  {{ amenity.quantity }}
                </section>

                <section>
                  <v-btn
                    class="block !h-full rounded-none py-2"
                    icon="mdi-plus"
                    variant="plain"
                    size="x-small"
                    @click="increaseAmenityQuantity(amenity)"
                  />
                </section>
              </section>
            </template>

            <template #subtitle>
              <section class="mt-2">
                <ProfitDisplay
                  :value="amenity.profit"
                  mode="chip"
                />
              </section>
            </template>

            <template #append>
              <v-btn
                icon="mdi-close"
                variant="plain"
                size="small"
                color="error"
                @click="unselectAmenity(amenity)"
              />
            </template>
          </v-list-item>
        </v-scroll-y-transition>
      </v-list>
    </section>
  </v-scroll-y-transition>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';
import { VSelect, VTextField } from 'vuetify/components';

import { HttpClient } from '@/http';
import { usePagination } from '@/composables';

import { MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { debounce } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import InlineLoadingIndicator from '@/components/layout/InlineLoadingIndicator.vue';

const props = defineProps<{ modelValue: IBookingAmenity[] }>();
const emit = defineEmits(['update:modelValue']);

const AMENITIES_LIST_SIZE = 10;

const pagination = usePagination({ size: AMENITIES_LIST_SIZE });

const amenities = ref<IAmenity[]>([]);
const selectedAmenities = ref<IBookingAmenity[]>(props.modelValue);

const term = ref('');
const isLoading = ref(false);

const checkAmenitySelected = (amenity: IBookingAmenity) => {
  return selectedAmenities.value.some(({ id }) => id === amenity.id);
};

const decreaseAmenityQuantity = (amenity: IBookingAmenity) => {
  const targetAmenity = selectedAmenities.value.find(({ id }) => {
    return id === amenity.id;
  });

  if (!targetAmenity || targetAmenity.quantity === 1) {
    return;
  }

  targetAmenity.quantity -= 1;
};

const increaseAmenityQuantity = (amenity: IBookingAmenity) => {
  const targetAmenity = selectedAmenities.value.find(({ id }) => {
    return id === amenity.id;
  });

  if (!targetAmenity) {
    return;
  }

  targetAmenity.quantity += 1;
};

const unselectAmenity = (amenity: IBookingAmenity) => {
  const targetAmenityIndex = selectedAmenities.value.findIndex(({ id }) => {
    return id === amenity.id;
  });

  if (targetAmenityIndex >= 0) {
    selectedAmenities.value.splice(targetAmenityIndex, 1);
  }
};

const selectAmenity = (amenity: IBookingAmenity) => {
  const selectedAmenityIndex = selectedAmenities.value.findIndex(({ id }) => {
    return id === amenity.id;
  });

  if (selectedAmenityIndex >= 0) {
    return unselectAmenity(amenity);
  }

  selectedAmenities.value.push(amenity);
};

const transformAmenitiesResponse = (amenities: IAmenity[]) => {
  return amenities.map(amenity => {
    return Object.assign(amenity, { quantity: 1 });
  });
};

const onFocus = async (isFocused: boolean) => {
  if (!isFocused || isLoading.value) {
    return;
  }

  await fetchData({ reset: true });
};

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (currentTerm && currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  term.value = currentTerm;
});

const onFullyScrolled = (isIntersecting: boolean) => {
  const isDataLoaded = (
    amenities.value.length < AMENITIES_LIST_SIZE
  );

  if (!isIntersecting || isDataLoaded) {
    return;
  }

  fetchData({ reset: false });
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  isLoading.value = true;

  if (options.reset) pagination.resetPage();
  if (!options.reset) pagination.nextPage();

  const response = await HttpClient.get<IAmenity[]>('/v1/amenities', {
    params: {
      limit: AMENITIES_LIST_SIZE,
      offset: pagination.offset.value,
      ...(term.value && { term: term.value }),
    },
  });

  isLoading.value = false;

  if (!response.data.values) {
    return;
  }

  const targetValues = transformAmenitiesResponse(
    response.data.values
  );

  amenities.value = options.reset
    ? targetValues
    : [...amenities.value, ...targetValues];
};

watch(term, () => fetchData({ reset: true }));
watch(selectedAmenities, amenities => {
  emit('update:modelValue', amenities);
});
</script>